Texture TargetMap; //scene (for alpha, for some reason the shaders needs it ???)
Texture mtlSkin1; //bumpmap (depthmap gets refracted by this)
Texture mtlSkin2; //depthmap (scene depth)
Texture mtlSkin3; //normalmap (optional)

float4 vecSkill1;
//float rayDepth = 0.011;
float rayDepth = 0.003;
//float scatterOffset = -0.0673; // 0.071
//float2 scatterOffset = {-0.071,-0.071};
static const int scatterNum = 8;

float2 scatterOffset[8] = {
	-0.078,-0.068,
	-0.068,-0.078,
	-0.058,-0.068,
	-0.068,-0.058,
	
	-0.058,-0.058,
	-0.078,-0.078,
	-0.078,-0.058,
	-0.058,-0.078,
	/*
	-0.088,-0.068,
	-0.068,-0.088,
	-0.048,-0.068,
	-0.068,-0.048,
	
	-0.088,-0.088,
	-0.048,-0.048,
	-0.048,-0.088,
	-0.088,-0.048
	*/
};


/*
float2 scatterOffset[8] = {
	-0.088,-0.068,
	-0.068,-0.088,
	-0.048,-0.068,
	-0.068,-0.048,
	
	-0.088,-0.088,
	-0.048,-0.048,
	-0.048,-0.088,
	-0.088,-0.048
};
*/

sampler ssaoSampler = sampler_state
{
   texture = (TargetMap);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler bumpSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
};

sampler depthSampler = sampler_state
{
   texture = (mtlSkin2);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler normalSampler = sampler_state
{
   texture = (mtlSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

float4 ssaoPS( float2 Tex : TEXCOORD0 ) : COLOR0 
{
	vecSkill1.x = 1.0; // ray scatter strength
	
	float depth = tex2D(depthSampler, Tex).r+tex2D(depthSampler, Tex).g/127;
	
	float4 bump = tex2D(bumpSampler, Tex*80);
	bump = normalize(bump);
	float4 bump2 = tex2D(normalSampler,Tex);
	bump2 = normalize(bump2);
	//bump = lerp(bump,bump2,0.5); //use scene normals
	float2 mid = ((Tex) + bump.xy * 0.15f * depth * vecSkill1.x);
	
	float4 pixel = tex2D(ssaoSampler, mid+float2(scatterOffset[0].x*vecSkill1.x*depth, scatterOffset[0].y*vecSkill1.x*depth));
	pixel.rgb = 0;
	float depth2 = 0;
	float depthBlur = 0;
	float ssao = 0;
	
	for(int i = 0; i < scatterNum; i++)
	{
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).r
					+ tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).g/127;

		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		depthBlur = clamp(depthBlur,0,1);
		
		ssao = depthBlur - depth;
		if(ssao > 0.0001)	ssao = 1;
		
		ssao = 1-ssao;
	
		pixel.rgb += ssao;
	}
	
	bump = tex2D(bumpSampler, Tex*85.765);
	bump = normalize(bump);
	//bump = lerp(bump,bump2,0.5); //use scene normals
	mid = ((Tex) + bump.xy * 0.15f * depth * vecSkill1.x);
	
	for(int i = 0; i < scatterNum; i++)
	{
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).r
					+ tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).g/127;

		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		ssao = depthBlur - depth;
		if(ssao > 0.0001)	ssao = 1;

		ssao = 1-ssao;
	
		pixel.rgb += ssao;
	}


	bump = tex2D(bumpSampler, Tex*92.826);
	bump = normalize(bump);
	//bump = lerp(bump,bump2,0.5); //use scene normals
	mid = ((Tex) + bump.xy * 0.15f * depth * vecSkill1.x);
	
	for(int i = 0; i < scatterNum; i++)
	{
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).r
					+ tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).g/127;

		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		ssao = depthBlur - depth;
		if(ssao > 0.0001)	ssao = 1;
		ssao = 1-ssao;
	
		pixel.rgb += ssao;
	}


	pixel.rgb /= scatterNum*3;
	//pixel.rgb *= ((1-cutOut)*(1-cutOut2)*(1-cutOut3));
	
	//pixel.rgb = pow(pixel.rgb,3);
	
	//if(pixel.r + pixel.g + pixel.b > 0.5) pixel.rgb = 1;

	return pixel;
}


technique ssao
{
	pass one
	{
		alphablendenable = false;
		PixelShader = compile ps_2_a ssaoPS();
	}
}