Texture TargetMap;
sampler2D normalSampler = sampler_state { texture = <TargetMap>; MipFilter = Linear;	};
sampler2D g_samSrcColor = sampler_state { texture = <TargetMap>; MipFilter = Linear;	};

Texture mtlSkin1;
sampler2D depthSampler = sampler_state { texture = <mtlSkin1>; MipFilter = Linear;	};

float4 vecViewPort;

/*
float4 postprocessing_sobel(float2 Tex : TEXCOORD0) : COLOR0 
{   
	float2 texCoord0 = Tex.xy + float2(-1.333 * vecViewPort.z,  0.0);
	float2 texCoord1 = Tex.xy + float2( 1.333 * vecViewPort.z,  0.0);
	float2 texCoord2 = Tex.xy + float2( 0.0, -1.333 * vecViewPort.w);
	float2 texCoord3 = Tex.xy + float2( 0.0,  1.333 * vecViewPort.w);
	float4 texCoord4 = Tex.xyyx + float4(-1.333 * vecViewPort.z, -1.25 * vecViewPort.w, -1.333 * vecViewPort.w, -1.25 * vecViewPort.z);
	float4 texCoord5 = Tex.xyyx + float4(-1.333 * vecViewPort.z,  1.25 * vecViewPort.w, -1.333 * vecViewPort.w,  1.25 * vecViewPort.z);
	float4 texCoord6 = Tex.xyyx + float4( 1.333 * vecViewPort.z, -1.25 * vecViewPort.w,  1.333 * vecViewPort.w, -1.25 * vecViewPort.z);
	float4 texCoord7 = Tex.xyyx + float4( 1.333 * vecViewPort.z,  1.25 * vecViewPort.w,  1.333 * vecViewPort.w,  1.25 * vecViewPort.z);
	
	float4 sobelX = 0.;
	float4 sobelY = 0.;

	sobelX += tex2D(g_samSrcColor, texCoord0) * 18.0;
	sobelX -= tex2D(g_samSrcColor, texCoord1) * 18.0;

	sobelY += tex2D(g_samSrcColor, texCoord2) * 18.0;
	sobelY -= tex2D(g_samSrcColor, texCoord3) * 18.0;

	sobelX += tex2D(g_samSrcColor, texCoord4.xy) * 15.0;
	sobelX += tex2D(g_samSrcColor, texCoord5.xy) * 15.0;
	sobelX -= tex2D(g_samSrcColor, texCoord6.xy) * 15.0;
	sobelX -= tex2D(g_samSrcColor, texCoord7.xy) * 15.0;

	sobelY += tex2D(g_samSrcColor, texCoord4.wz) * 15.0;
	sobelY += tex2D(g_samSrcColor, texCoord5.wz) * 15.0;
	sobelY -= tex2D(g_samSrcColor, texCoord6.wz) * 15.0;
	sobelY -= tex2D(g_samSrcColor, texCoord7.wz) * 15.0;
	
	sobelX /= 12.0;
	sobelY /= 12.0;
	
	return sqrt(sobelX * sobelX + sobelY * sobelY);
	//return tex2D(g_samSrcColor, Tex);
}

technique PostProcess 
{
	pass p1 
	{
		AlphaBlendEnable = false;	
		VertexShader = null;
		PixelShader = compile ps_2_0 postprocessing_sobel();
	}
}
*/


float blurStr = 0.005;

float2 texTab[8] =
{
	1, 0,
	-1, 0,
	0, 1,
	0, -1,
	1, 1,
	-1, -1,
	1, -1,
	-1, 1
};

float4 ssaoEdge_PS(float2 inTex:TEXCOORD0):COLOR0
{
	float4 color = 1;
	
	int i;
	for (i = 0; i < 8; i++)
	{ 
		color.rgb += tex2D(normalSampler, inTex+texTab[i]*blurStr);
	}
	
	color.rgb /= 8;
	color.rgb -= tex2D(normalSampler, inTex);
	//color.rgb = clamp(color.rgb,0,1);
	//color.rgb = 1-color.rgb;
	//color.rgb = normalize(color.rgb);
	//color.rgb = dot(1,color.rgb);
	//color.rgb = dot(0,color.rgb);
	//color.rgb = dot(1,color.rgb);
	//color.rgb = normalize(color.rgb);
	//color.rgb = clamp(color.rgb,0,1);
	//if(color.r + color.g + color.b <= 0) color.rgb = 1;
	//color.rgb = pow(color.rgb,2);
	
	float ssao = (color.r + color.g + color.b)/3;
	color.rgb = ssao;
	//if(ssao < 0.2) color.rgb = 1;
	
	return color;
}


technique ssaoEdge
{
	pass p0
	{
		PixelShader = compile ps_2_0 ssaoEdge_PS();
	}
}
