/*******************************************************************************************************************************************************
HYBRID RENDERER
*********************************************************************************************************************************************************/

#define PRAGMA_PATH "shade-c"
#define PRAGMA_PATH "stuff"
#define PRAGMA_PATH "misc"

#include <litec.h>
#include <d3d9.h> // <--- THIS IS IMPORTANT!
#include <acknex.h>
#include <default.c>
#include "sc_core.c"
//#include "sc_pointShadow.c"
#include "effects.h"
#include "effects.c"

ENTITY* skycube =
{
  type = "sky04+6.tga"; // the image for a backdrop scene
  flags2 = SKY | CUBE | VISIBLE; // sky cube, visible
  red = 140;
  green = 140;
  blue = 140;
}

void ent_camera()
{
	set(my,INVISIBLE);
	set(my,PASSABLE);
	while(1)
	{
		c_move(my,vector(key_force.y*10*time_step,-key_force.x*10*time_step,0),nullvector,GLIDE + IGNORE_PASSABLE);
		my.pan += -mickey.x;
		my.tilt += -mickey.y;
		
		vec_set(camera.x,my.x);
		vec_set(camera.pan,my.pan);
		wait(1);
	}
}

MATERIAL* mtl_wpos =
{
	effect = "wpos.fx";
}

VECTOR sc_customLights[16];

void main ()
{
	video_switch(8,32,0);
	camera.arc = 90;
	level_load("level.wmb");
	//level_load(NULL);
	
	wait(3);
bmap_to_cubemap(sc_map_aioEnvmap);
	//setup shade-c so we can use light rays. We don't need any advanced effects, so disable them
	sc_bHDR = 1;
	sc_bDOF = 1;
	sc_bRefract = 1;
	sc_bReflect = 0;
	sc_bWater = 0;
	sc_bVolParts = 1;
	sc_setup();
	
	//set skycube as non volumetric particle, this is needed. ALWAYS! (well, not always, but most of the time. It doesn't hurt to set this)
	sc_skill(skycube,sc_myVolPart, 0);
	sc_skill(skycube,sc_myDepth, -1);
	
	//set light ray strength and length. These can be set during runtime to alter the effect in realtime
	sc_lightRayStr = 0.4;
	sc_lightRayLength = 4.5;
	
	//activate light rays
	//sc_lightRays();
	
	//create camera
	ent_create("xyz.mdl",vector(0,0,20),ent_camera);
	
	
	
	//make the sun panel dummy visible, just so you know where the sun is ;)
	set(sc_pan_sunDummy,SHOW);
	
	//tilt the sun to 20, so we don't have to look up in the sky to find the sun, this is just to better show the light ray effect
	sun_angle.tilt = 30;
	sun_angle.pan = 0;


	//ent_create("xyz.mdl",vector(0,0,20),ent_camera);
	//sc_smSunSetup(screen_size.x, 2000, 1000, 0.002, 0);
	wait(1);


	//sc_skill(skycube,sc_myDepth, -1);
	
	skycube.skill1 = 2;
	//sc_setupObjShadow(you);
	//you = ent_create("room2.mdl",vector(0,0,0),NULL);
	//vec_scale(you.scale_x,2);
	
	wait(25);
	sc_lightRays();
	
	
	while(1)
	{
		sun_angle.pan += time_step/2;
		wait(1);
	}
	//sc_mtl_pp_show.skin1 = sc_map_shadowDepthSun;
	
	//sc_ppAdd(sc_mtl_pp_show,camera,0);
	//sc_setupDeferred();
	
/*	
	sc_smSunSetup(screen_size.x, 2000, 1000, 0.002, 0);

	wait(3);
	//sc_setupDepth();
	sc_setupDeferred();
	
	
	vec_set(sc_customLights[0],vector(70,150,20));
	vec_set(sc_customLights[1],vector(-70,150,20));
	vec_set(sc_customLights[2],vector(0,-150,20));
	vec_set(sc_customLights[3],vector(70,-150,20));
	vec_set(sc_customLights[4],vector(-170,50,20));
	vec_set(sc_customLights[5],vector(170,50,20));
	vec_set(sc_customLights[6],vector(-170,-50,20));
	vec_set(sc_customLights[7],vector(70,50,20));
	
	vec_set(sc_customLights[8],vector(30,70,20));
	vec_set(sc_customLights[9],vector(-35,70,20));
	vec_set(sc_customLights[10],vector(0,-70,20));
	vec_set(sc_customLights[11],vector(35,-70,20));
	vec_set(sc_customLights[12],vector(-80,25,20));
	vec_set(sc_customLights[13],vector(80,25,20));
	vec_set(sc_customLights[14],vector(-80,-25,20));
	vec_set(sc_customLights[15],vector(35,25,20));
	
	
	//camera.material = sc_mtl_shadowObject;
	//camera.stage = sc_view_shadowObject;
	*/
}