


const float4x4 matWorld;
const float4x4 matWorldInv;
const float4x4 matWorldViewProj;

float4 vecSkill1;


struct VS_IN
{
	float4 pos	:	POSITION;
	float2 tex	:	TEXCOORD0;
	float3 normal : NORMAL;
	float3 tangent : TEXCOORD0;
};

struct VS_OUT
{
	float4 pos	:	POSITION;
	float2 tex	:	TEXCOORD0;
	//float3 norm	:	TEXCOORD1;
	float2 wPos	:	TEXCOORD1;
	float3 tangent : TEXCOORD2;
	float3 binormal : TEXCOORD3;
	float3 normal : TEXCOORD4;


};


struct PS_IN
{
	float2 tex	:	TEXCOORD0;
	//float3 norm	:	TEXCOORD1;
	float3 pos	:	TEXCOORD1;
	float3 tangent : TEXCOORD2;
	float3 binormal : TEXCOORD3;
	float3 normal : TEXCOORD4;



};


struct PS_OUT
{
	float4 col	:	COLOR0;
	float4 norm	:	COLOR1;
	float4 pos	:	COLOR2;
};

texture entSkin1;
texture entSkin2;
texture entSkin3;

sampler colorSampler = sampler_state
{
	Texture = <entSkin1>;
	MagFilter = LINEAR;
   MinFilter = LINEAR;
   Mipfilter = LINEAR;
   AddressU = Wrap;
   AddressV = Wrap;
};


sampler maskSampler = sampler_state
{
    Texture = (entSkin2);
    MagFilter = LINEAR;
    MinFilter = LINEAR;
    Mipfilter = LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};


sampler normalSampler = sampler_state
{
    Texture = (entSkin3);
    MagFilter = LINEAR;
    MinFilter = LINEAR;
    Mipfilter = LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};


VS_OUT gBuffer_vs(VS_IN IN)
{
	VS_OUT OUT;
	
	OUT.pos = mul(IN.pos,matWorldViewProj);
	OUT.tex = IN.tex;
	//OUT.norm = mul(IN.norm,matWorld);
	OUT.wPos.x = OUT.pos.z;
	OUT.wPos.y = OUT.pos.w;
	
	
	float3 Binormal = cross(IN.normal,IN.tangent);
	OUT.normal = mul(IN.normal, matWorld).xyz;
	OUT.tangent = mul(IN.tangent, matWorldInv).xyz;
	OUT.binormal = mul(Binormal, matWorldInv).xyz;	
	/*
   OUT.tangent = mul(IN.Tangent, matWorld).xyz;
   OUT.binormal = mul(IN.Binormal, matWorld).xyz;
   OUT.normal = mul(IN.Normal, matWorld).xyz;
*/
	return OUT;
}

PS_OUT gBuffer_ps(VS_OUT IN)
{
	PS_OUT OUT;
	clip(tex2D(colorSampler,IN.tex).a-0.5);
	
	OUT.col  = tex2D(colorSampler,IN.tex);
	OUT.col.a = tex2D(maskSampler,IN.tex).g; //EnvMap Intensity
	OUT.pos = IN.wPos.x / IN.wPos.y;
		
	//OUT.norm.rgb = 0.5f * (normalize(IN.normal) + 1.0f);
	//OUT.norm.a = tex2D(maskSampler,IN.tex).r; // specularIntensity
	
	float3x3 tangentToWorld;
	tangentToWorld[0] = normalize(IN.tangent);
	tangentToWorld[1] = normalize(IN.binormal);
	tangentToWorld[2] = normalize(IN.normal);
	float3 normalFromMap = tex2D(normalSampler, IN.tex).xyz;
    //tranform to [-1,1]
    normalFromMap = 2.0f * normalFromMap - 1.0f;
    //transform into world space
    normalFromMap = mul(normalFromMap, tangentToWorld);
    //normalize the result
    normalFromMap = normalize(normalFromMap);
    //output the normal, in [0,1] space
    if(vecSkill1.z > 0)
	{
		 OUT.pos = 0;
		 //normalFromMap = normalize(IN.normal);
	}
	
	/*
	float3 bumpNormal= 1 * (tex2D(normalSampler, IN.tex).xyz-(0.5).xxx);
	float3 Nb = normalize(IN.normal) + (bumpNormal.x * normalize(IN.tangent) + bumpNormal.y * normalize(IN.binormal));
   Nb = normalize(Nb);
	*/
    OUT.norm.rgb = 0.5f * (normalFromMap + 1.0f);
    //OUT.norm.rgb = Nb;
    
    OUT.norm.a = tex2D(maskSampler,IN.tex).r; // specularIntensity
	
	
	return OUT;
}

technique gBuffer
{
	pass p0
	{
		alphablendenable = false;
		VertexShader = compile vs_2_0 gBuffer_vs();
		PixelShader  = compile ps_2_0 gBuffer_ps();
	}
}
