Texture TargetMap; //scene
Texture mtlSkin1; //bumpmap (scene gets refracted by this)
Texture mtlSkin2; //depthmap (scene depth)
Texture mtlSkin3; //normal

matrix matWorldViewProj;
matrix matWorld;

float4 vecSkill1;

//float rayDepth = 0.0035; //depth
//float rayDepth2 = 0.002; //normals
float rayDepth = 0.0035; //depth
float rayDepth2 = 0.002; //normals
float GIbrightness = 0.5;

static const int scatterNum = 9;

float2 scatterOffset[9] = {
	0.0, 0.0,
	
	1.3 , 0.0,
	0.0 , 2.0,
	-1.3, 0.0,
	0.0, -2.0,
	
	1.0, 1.3,
	-1.0, 1.3,
	1.0, -1.3,
	-1.0, -1.3,
	/*
	0.0, 0.0,
	
	1.0 , 0.0,
	0.0 , 2.0,
	-1.0, 0.0,
	0.0, -2.0,
	
	1.0, 2.0,
	-1.0, 2.0,
	1.0, -2.0,
	-1.0, -2.0,
	*/

};

float2 scatterOffset_[4] = {
	//-0.07,-0.07
	
	
	-0.078,-0.068,
	-0.068,-0.078,
	-0.058,-0.068,
	-0.068,-0.058,
	
	/*
	-0.058,-0.058,
	-0.078,-0.078,
	-0.078,-0.058,
	-0.058,-0.078,
	*/
	
};

float2 scatterOffset2[8] = {
	-0.078,-0.078,
	0.078,0.078,
	-0.078,0.078,
	0.078,-0.078,
	
	-0.038,-0.038,
	0.038,0.038,
	-0.038,0.038,
	0.038,-0.038,
};


sampler sceneSampler = sampler_state
{
   texture = (mtlSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler bumpSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
};

sampler depthSampler = sampler_state
{
   texture = (mtlSkin2);
   MinFilter = point;
   MagFilter = point;
   MipFilter = point;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler normalSampler = sampler_state
{
   texture = (TargetMap);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

float rand(float2 co){

        return 0.5+(frac(sin(dot(co.xy ,float2(12.9898,78.233))) * 43758.5453))*0.5;

}

float4 giPS(float2 Tex : TEXCOORD0, uniform float bumpTile) : COLOR0 
{
	vecSkill1.x = 0.025; // ray scatter strength
	//vecSkill1.y = 0.5; // ray scatter strength (blur)
	
	vecSkill1.x = bumpTile;
	
	float depth = tex2D(depthSampler, Tex).r;//+tex2D(depthSampler, Tex).g/127;
	float depthC = depth;
	float3 normals = tex2D(normalSampler,Tex).xyz;
	
	float4 bump = tex2D(bumpSampler, Tex*bumpTile);
	bump = normalize(bump);
	float4 bump2 = tex2D(normalSampler,Tex);
	//bump2 = normalize(bump2);
	//bump = lerp(bump,bump2,0.5); //use scene normals
	//float2 mid = ((Tex) + bump.xy * 0.15f * depthC * vecSkill1.x);
	//float2 mid = ((Tex) + bump.xy * 0.6f * depthC) - float2(0.27, 0.27);
	
	/*
	float ratex = (1.0/1024.0);
	float ratey = (1.0/768.0);
	float zFar = 8.0;
	float zNear = 0.3;
	float incx2 = ratex*8;//ao radius
	float incy2 = ratey*8;
	float prof = depth;
	prof = zFar * zNear / (prof * (zFar - zNear) - zFar);  //linearize z sample
	float2 coords2 = float2(1*incx2,1*incy2)/prof;
	*/
	float2 mid = Tex.xy;//+coords2*rand(Tex.xy);





	//float2 mid = ((Tex) + bump.xy * 0.15f * vecSkill1.x);

	
	//mid = Tex;
	
	float3 orgColor = tex2D(sceneSampler, Tex).xyz;
	float4 pixel = tex2D(sceneSampler, Tex);//mid+float2(scatterOffset[0].x*vecSkill1.x*depth, scatterOffset[0].y*vecSkill1.x*depth));
	float depth2 = 0;
	float depthBlur = 0;
	float ssao = 0;
	float ssaoRDY = 0;
	float3 gi = 0;
	float3 colorBCK = pixel.xyz;
	pixel.rgb = 0;
	float3 normals2 = 0;

	for(int i = 0; i < scatterNum; i++)
		{	
		
		
		
		/*
		gi = tex2D(sceneSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).r;
		normals2 = tex2D(normalSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		*/
		
		gi = tex2D(sceneSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).r;
		normals2 = tex2D(normalSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		
		//---GI---
		if(
		depth2 - depth <= rayDepth
		&& depth2 - depth >= -rayDepth
		&& depth2 - depth != 0
		&& ((normals.r - normals2.r > rayDepth2 || normals.g - normals2.g > rayDepth2 || normals.b - normals2.b > rayDepth2)
			|| (normals.r - normals2.r < -rayDepth2 || normals.g - normals2.g < -rayDepth2 || normals.b - normals2.b < -rayDepth2))
		)
		{	

			if(gi.r > GIbrightness) pixel.r += gi.r;//*(depth2-depth)*100;
			if(gi.g > GIbrightness) pixel.g += gi.g;
			if(gi.b > GIbrightness) pixel.b += gi.b;
			//if(gi.r > 0.8) pixel.r -= gi.r;
			//if(gi.g > 0.8) pixel.g -= gi.g;
			//if(gi.b > 0.8) pixel.b -= gi.b;
		} 
		
		
		
		//---SSAO---
		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		depthBlur = clamp(depthBlur,0,1);
		
		ssao = depthBlur - depth;
		if(ssao > 0.0004
		&& ((normals.r - normals2.r > rayDepth2*90 || normals.g - normals2.g > rayDepth2*90 || normals.b - normals2.b > rayDepth2*90)
			|| (normals.r - normals2.r < -rayDepth2*90 || normals.g - normals2.g < -rayDepth2*90 || normals.b - normals2.b < -rayDepth2*90))
		)	ssao = 1;
		
		ssaoRDY += ssao;

	}


	pixel.rgb /= scatterNum;

	pixel.rgb *= 0.45;
	//pixel.a = ((ssaoRDY/scatterNum))*128;
	pixel.a = (ssaoRDY/scatterNum)*0.25;
	//pixel.a = clamp(pixel.a,0,1);
	
	//pixel.rgb = bump2;
	
	//pixel.rgb /= 2;
	
	//pixel.rgb = tex2D(sceneSampler, Tex*2).xyz*tex2D(normalSampler, Tex).xyz;
	//pixel.rgb = tex2D(normalSampler, Tex).xyz;
	return pixel;
}




float4 giPS2(float2 Tex : TEXCOORD0, uniform float bumpTile, uniform float scatterStr) : COLOR0 
{
	vecSkill1.x = scatterStr; // ray scatter strength
	//vecSkill1.y = 0.5; // ray scatter strength (blur)
	
	//vecSkill1.x = bumpTile;
	
	float depth = tex2D(depthSampler, Tex).r;//+tex2D(depthSampler, Tex).g/127;
	float depthC = depth;
	float3 normals = tex2D(normalSampler,Tex).xyz;
	
	float4 bump = tex2D(bumpSampler, Tex*bumpTile);
	bump = normalize(bump);
	float4 bump2 = tex2D(normalSampler,Tex);
	//bump2 = normalize(bump2);
	//bump = lerp(bump,bump2,0.5); //use scene normals
	float2 mid = ((Tex) + bump.xy * 0.15f * depthC * vecSkill1.x);
	//float2 mid = ((Tex) + bump.xy * 0.6f * depthC) - float2(0.27, 0.27);
	
	/*
	float ratex = (1.0/1024.0);
	float ratey = (1.0/768.0);
	float zFar = 8.0;
	float zNear = 0.3;
	float incx2 = ratex*8;//ao radius
	float incy2 = ratey*8;
	float prof = depth;
	prof = zFar * zNear / (prof * (zFar - zNear) - zFar);  //linearize z sample
	float2 coords2 = float2(1*incx2,1*incy2)/prof;
	*/
	//float2 mid = Tex.xy;//+coords2*rand(Tex.xy);





	//float2 mid = ((Tex) + bump.xy * 0.15f * vecSkill1.x);

	
	//mid = Tex;
		
	float4 pixel = tex2D(sceneSampler, Tex);//mid+float2(scatterOffset[0].x*vecSkill1.x*depth, scatterOffset[0].y*vecSkill1.x*depth));
	float depth2 = 0;
	float depthBlur = 0;
	float ssao = 0;
	float ssaoRDY = 0;
	float3 gi = 0;
	float3 colorBCK = pixel.xyz;
	pixel.rgb = 0;
	float3 normals2 = 0;

	for(int i = 0; i < scatterNum; i++)
		{	
		
		
		
		/*
		gi = tex2D(sceneSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).r;
		normals2 = tex2D(normalSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		*/
		
		gi = tex2D(sceneSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).r;
		normals2 = tex2D(normalSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		
		//---GI---
		if(
		depth2 - depth <= rayDepth
		&& depth2 - depth >= -rayDepth
		&& depth2 - depth != 0
		&& ((normals.r - normals2.r > rayDepth2 || normals.g - normals2.g > rayDepth2 || normals.b - normals2.b > rayDepth2)
			|| (normals.r - normals2.r < -rayDepth2 || normals.g - normals2.g < -rayDepth2 || normals.b - normals2.b < -rayDepth2))
		)
		{	
			if(gi.r > GIbrightness) pixel.r += gi.r;//*(depth2-depth)*100;
			if(gi.g > GIbrightness) pixel.g += gi.g;
			if(gi.b > GIbrightness) pixel.b += gi.b;
		} 
		
		
		
		//---SSAO---
		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		depthBlur = clamp(depthBlur,0,1);
		
		ssao = depthBlur - depth;
		if(ssao > 0.0004
		&& ((normals.r - normals2.r > rayDepth2*90 || normals.g - normals2.g > rayDepth2*90 || normals.b - normals2.b > rayDepth2*90)
			|| (normals.r - normals2.r < -rayDepth2*90 || normals.g - normals2.g < -rayDepth2*90 || normals.b - normals2.b < -rayDepth2*90))
		)	ssao = 1;
		
		ssaoRDY += ssao;

	}


	pixel.rgb /= scatterNum;

	pixel.rgb *= 0.845;
	//pixel.a = ((ssaoRDY/scatterNum))*128;
	pixel.a = (ssaoRDY/scatterNum)*0.225;
	//pixel.a = clamp(pixel.a,0,1);
	
	//pixel.rgb = bump2;
	
	//pixel.rgb /= 2;
	
	//pixel.rgb = tex2D(sceneSampler, Tex*2).xyz*tex2D(normalSampler, Tex).xyz;
	//pixel.rgb = tex2D(normalSampler, Tex).xyz;
	return pixel;
}


technique ssao
{
/*
	pass p0
	{
		alphablendenable = false;
		PixelShader = compile ps_2_a giPS2(float(60),float(1.17));
	}
	
	pass p1
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS2(float(63.32),float(2.53));
	}
	pass p2
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS2(float(65.95),float(2.29));
	}
*/



	pass p0
	{
		alphablendenable = false;
		PixelShader = compile ps_2_a giPS(float(0.010));
	}
	
	pass p1
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.15));
	}
	pass p2
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.20));
	}
	
	pass p3
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.030));
	}
	
	pass p4
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.040));
	}
	
	pass p5
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.050));
	}
	
	/*
	pass p0
	{
		alphablendenable = false;
		PixelShader = compile ps_2_a giPS(float(0.005));
	}
	
	pass p1
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.010));
	}
	pass p2
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.015));
	}
	
	pass p3
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.030));
	}
	
	pass p4
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.040));
	}
	
	pass p5
	{
		alphablendenable=true;
   	 srcblend=one;
    	 destblend=one;
		PixelShader = compile ps_2_a giPS(float(0.060));
	}
	*/
	
}