
Texture mtlSkin1; //bumpTex
Texture entSkin1; //entSkin
Texture entSkin3; //normalmap

float4 vecViewPos;

matrix matWorld;
matrix matView;
matrix matWorldView;
matrix matWorldViewProj;
matrix matProj;

sampler bumpSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Wrap;
   AddressV = Wrap;
};

sampler colorSampler = sampler_state
{
   texture = (entSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler normalSampler = sampler_state
{
   texture = (entSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

void giVS( 
   in float4 InPos: POSITION,
   in float3 InNormal: NORMAL,
   in float2 InTex : TEXCOORD0,
   in float3 InTangent : TEXCOORD2,
   out float2 OutTex : TEXCOORD0,
   out float3 OutNormal: TEXCOORD1,
   out float4 OutPos: POSITION
)
{
	OutPos = mul(InPos, matWorldViewProj); 
	float3 PosWorld = mul(InPos, matWorld);

	//OutNormal = normalize(mul(InNormal, matProj));
	OutNormal = PosWorld;//normalize(mul(InNormal, matProj));
	
	OutTex = InTex;
}

float4 giPS(float2 Tex : TEXCOORD0, float3 inNormal : TEXCOORD1) : COLOR0 
{
	float4 color = tex2D(colorSampler,Tex);
	//color.rgb = tex2D(bumpSampler,Tex*10);
	color.rgb = inNormal;
	//color.rgb = tex2D(normalSampler,Tex).xyz;
	return color;
}


technique ssao
{
	pass one
	{
		//alphablendenable = false;
		//SHADEMODE = FLAT;
		VertexShader = compile vs_2_0 giVS();
		PixelShader = compile ps_2_0 giPS();
		
	}
}

