texture TargetMap;
texture mtlSkin1;

sampler depthSampler = sampler_state 
{ 
   Texture = <mtlSkin1>; 
   //MinFilter = Linear;
	//MagFilter = Linear;
	//MipFilter = Linear;
};

sampler colorSampler = sampler_state 
{ 
   Texture = <TargetMap>; 
   MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};

float blurStr = 0.01;
float ssaoDepth = 0.01;

float2 texTab[8] =
{
	1, 0,
	-1, 0,
	0, 1,
	0, -1,
	1, 1,
	-1, -1,
	1, -1,
	-1, 1
};

float4 ssao_ps(float2 inTex:TEXCOORD0):COLOR0
{
	/*
	float depth = tex2D(depthSampler, inTex).r;
	float depthBlur = 0;
	float ssao = 1;
	
	
	float blurTab;
	int i;
	for (i = 0; i < 8; i++)
	{ 
		blurTab = tex2D(depthSampler, inTex+texTab[i]*blurStr*depth).r;
		if(blurTab - depth < 0.3) depthBlur += blurTab;
	}
	
	depthBlur /= 8;
	
	ssao = depthBlur - depth;
	if(ssao > 0) ssao = 1;
	//pow()
	ssao = 1-ssao;
	*/
	
	
	
	
	
	
	float depth = tex2D(depthSampler, inTex).r+tex2D(depthSampler, inTex).g/127;
	float depthBlur = 0;
	float ssao = 1;
	
	
	float blurTab;
	int i;
	for (i = 0; i < 8; i++)
	{ 
		blurTab = tex2D(depthSampler, inTex+texTab[i]*blurStr*depth).r+tex2D(depthSampler, inTex+texTab[i]*blurStr*depth).g/127;
		if(blurTab - depth <= 0.006) depthBlur += blurTab;
	}
	
	depthBlur /= 8;
	
	ssao = depthBlur - depth;
	//ssao -= 0.0005;
	if(ssao > 0) ssao = 1;
	//pow()
	ssao = 1-ssao;
	
	
	
	//ssao = tex2D(depthSampler, inTex).r+tex2D(depthSampler, inTex).g/127;
	//return tex2D(colorSampler,inTex)*ssao;
	
	
	//return float4(ssao,ssao,ssao,depth);
	return float4(ssao,ssao,ssao,1);
}

technique ssao
{
	pass p0
	{
		alphablendenable = false;
		PixelShader = compile ps_2_0 ssao_ps();
	}
}