Texture TargetMap; //ssao
Texture mtlSkin1; //bumpmap
Texture mtlSkin2; //depthmap
Texture mtlSkin3; //normalmap

float4 vecSkill1;
//float rayDepth = 0.011;
float rayDepth = 0.002;
//float scatterOffset = -0.0673; // 0.071
//float2 scatterOffset = {-0.071,-0.071};
float2 scatterOffset = {-0.051,-0.071};

sampler ssaoSampler = sampler_state
{
   texture = (TargetMap);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler bumpSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
};

sampler depthSampler = sampler_state
{
   texture = (mtlSkin2);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler normalSampler = sampler_state
{
   texture = (mtlSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

float4 ssaoPS( float2 Tex : TEXCOORD0 ) : COLOR0 
{
	vecSkill1.x = 1.20; // ray scatter strength
	
	float depth = tex2D(depthSampler, Tex).r+tex2D(depthSampler, Tex).g/127;
	
	float4 bump = tex2D(bumpSampler, Tex*80);
	bump = normalize(bump);
	float4 bump2 = tex2D(normalSampler,Tex);
	bump2 = normalize(bump2);
	//bump = lerp(bump,bump2,0.5);
	float2 mid = ((Tex) + bump.xy * 0.15f * depth * vecSkill1.x);
	
	/*
	float4 pixel = tex2D(ssaoSampler, mid+float2(-0.0573*vecSkill1.x*depth, -0.0573*vecSkill1.x*depth));
	float depth2 = tex2D(depthSampler, mid+float2(-0.0573*vecSkill1.x*depth, -0.0573*vecSkill1.x*depth)).r
						+ tex2D(depthSampler, mid+float2(-0.0573*vecSkill1.x*depth, -0.0573*vecSkill1.x*depth)).g/127;
						*/
	float4 pixel = tex2D(ssaoSampler, mid+float2(scatterOffset.x*vecSkill1.x*depth, scatterOffset.y*vecSkill1.x*depth));
	float depth2 = tex2D(depthSampler, mid+float2(scatterOffset.x*vecSkill1.x*depth, scatterOffset.y*vecSkill1.x*depth)).r
						+ tex2D(depthSampler, mid+float2(scatterOffset.x*vecSkill1.x*depth, scatterOffset.y*vecSkill1.x*depth)).g/127;

	

	float depthBlur = 0;
	if(depth2 - depth <= rayDepth) depthBlur += depth2;
	
	float ssao = depthBlur - depth;
	if(ssao > 0.0001) ssao = 1;
	ssao = 1-ssao;
	
	pixel.rgb = ssao;
	
	//pixel.a = clamp(depth,0,1);
	return pixel;
}


technique emboss
{
	pass one
	{
		alphablendenable = false;
		PixelShader = compile ps_3_0 ssaoPS();
	}
}